# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/apache-slide/2.1-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section   devel
%define base_name slide
%define jakarta_version 2.1

Name:           jakarta-%{base_name}-webdavclient
Version:        %{jakarta_version}
Release:        9%{?dist}
Epoch:          0
Summary:        Slide WebDAV client
Group:          Development/Libraries/Java
License:        ASL 2.0
URL:            http://jakarta.apache.org/slide/
Source0:        jakarta-slide-webdavclient-src-2.1.tar.gz
Source1:        %{name}.sh
Source2:        jakarta-slide-webdavclient-2.2-WebdavResource.java
Source3:	jakarta-slide-webdavclient-component-info.xml
Source4:        http://mirrors.ibiblio.org/pub/mirrors/maven2/slide/slide-webdavlib/2.1/slide-webdavlib-2.1.pom
# FIXME Temporary fix !!!
Patch0:		jakarta-slide-webdavclient-3.0-compat.patch
Patch1:		jakarta-slide-webdavclient-build-jdk15.patch
Patch2:		jakarta-slide-webdavclient-jdk15.patch
BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5.32
BuildRequires:  ant >= 0:1.6
BuildRequires:  antlr
BuildRequires:  ant-antlr
BuildRequires:  jakarta-commons-httpclient >= 3.0
BuildRequires:  jakarta-commons-transaction
BuildRequires:  geronimo-j2ee-1.4-apis
BuildRequires:  jdom
BuildRequires:  xml-im-exporter
Requires:  jakarta-commons-httpclient
Requires:  jakarta-commons-transaction
Requires:  geronimo-j2ee-1.4-apis
Requires:  jdom
Requires:  xml-im-exporter
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Slide includes a fully featured WebDAV client library and command line
client.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.


%prep
%setup -q -n jakarta-slide-webdavclient-src-2.1
find . -name "*.jar" | xargs %{__rm}
#for j in $(find . -name "*.jar"); do
#	mv $j $j.no
#done
cp -p %{SOURCE2} clientlib/src/java/org/apache/webdav/lib/WebdavResource.java

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
export CLASSPATH=$(build-classpath \
antlr \
commons-httpclient \
commons-transaction \
geronimo-j2ee-1.4-apis \
jdom \
xml-im-exporter \
)
ant -Dbuild.sysclasspath=first

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_bindir}
install -pm 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/webdavclient

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{base_name}
install -pm 644 \
 dist/lib/jakarta-slide-webdavlib-%{jakarta_version}.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}
ln -s jakarta-slide-webdavlib-%{jakarta_version}.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-webdavlib-%{version}.jar

install -pm 644 \
 dist/lib/jakarta-slide-commandline-%{jakarta_version}.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}

ln -s jakarta-slide-commandline-%{jakarta_version}.jar \
 $RPM_BUILD_ROOT%{_javadir}/%{base_name}/%{name}-commandline-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name} && for jar in jakarta-*.jar; do ln -sf ${jar} `echo $jar| sed  "s|jakarta-||g"`; done)

#javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/doc/clientjavadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%add_to_maven_depmap slide %{base_name}-webdavlib %{version} JPP/slide jakarta-slide-webdavlib

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
        sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
        sed -i "s/@VERSION@/%{version}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp -p $RPM_BUILD_ROOT%{_javadir}/slide/jakarta-slide-webdavlib.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%doc LICENSE
%{_javadir}/%{base_name}/*.jar
%attr(0755,root,root) %{_bindir}/webdavclient
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Tue Aug 12 2008 David Walluck <dwalluck@redhat.com> 0:2.1-9
- really fix maven info
- remove commons-httpclient-contrib from CLASSPATH

* Tue Aug 12 2008 David Walluck <dwalluck@redhat.com> 0:2.1-8
- fix maven info

* Tue Aug 12 2008 David Walluck <dwalluck@redhat.com> 0:2.1-7
- fix component-info.xml

* Tue Aug 12 2008 David Walluck <dwalluck@redhat.com> 0:2.1-6
- add maven support

* Fri Jun 20 2008 David Walluck <dwalluck@redhat.com> 0:2.1-5.jpp5
- fix build root
- fix License
- remove javadoc scriptlets

* Mon Jun 02 2008 Permaine Cheung <pcheung@redhat.com> - 0:2.1-4
- First JPP5 build

* Thu Jul 26 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3jpp.ep1.3.1
- Rebuild with JDK 1.4

* Fri Jul 06 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3jpp.ep1.3
- Patch to allow compilation with Java 5

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1-3jpp.ep1.2
- Fix repolib location

* Mon Mar 05 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3jpp.ep1.1
- Rebuild

* Mon Mar 05 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3jpp.el4ep1.3
- Rebuild with proper fix

* Fri Mar 02 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3jpp.el4ep1.2
- Require only the j2ee APIs, not the full geronimo-specs

* Wed Feb 21 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1-3jpp.el4ep1.1
- Add repolib support
- Add missing BR on ant-antlr

* Fri Apr 21 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3jpp_0rh
- First Red Hat build (not ready for release)

* Fri Apr 21 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3jpp
- First JPP 1.7 build
- Add patch from Deepak Bhole <dbhole@redhat.com> so it builds with
  j-c-httpclient 3.0

* Mon Sep 05 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1-2jpp
- Fix requires

* Wed Aug 24 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1-1jpp
- Upgrade to 2.1
- WebdavResource.java backported from 2.2 for commons-vfs

* Sat Sep 18 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-1jpp
- Upgrade to 2.0 final

* Tue Aug 24 2004 Randy Watler <rwatler at finali.com> - 0:2.0-0.b1.4jpp
- Rebuild with ant-1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.0-0.b1.3jpp
- Upgrade to Ant 1.6.X

* Wed Mar 31 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0-0.b1.2jpp
- Fix build and runtime dependencies.
- Install a working startup script.

* Fri Mar 04 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-0.b1.1jpp
- First JPackage release
